/*******************************************************************************

   G:\Customers\MITJared\data062311\dynGaitModel_PL\dynsim\src\model.h

   Created by SIMM 6.0 (from joint file G:\Customers\MITJared\data062311\GaitModel_PL.jnt)

   Time of creation: 07/06/2011 04:28:52 PM

*******************************************************************************/

/*********** Joints ************/
#define             gnd_pelvis  0
#define            pelvis_lum5  1
#define              lum5_lum4  2
#define              lum4_lum3  3
#define              lum3_lum2  4
#define              lum2_lum1  5
#define             lum1_torso  6
#define         lumbar_dof_jnt  7
#define            torso_cerv7  8
#define            cerv7_cerv6  9
#define            cerv6_cerv5 10
#define            cerv5_cerv4 11
#define            cerv4_cerv3 12
#define            cerv3_cerv2 13
#define            cerv2_cerv1 14
#define             cerv1_head 15
#define       cervical_dof_jnt 16
#define             acromial_r 17
#define                elbow_r 18
#define           radioulnar_r 19
#define         radius_wflex_r 20
#define           wflex_hand_r 21
#define             acromial_l 22
#define                elbow_l 23
#define           radioulnar_l 24
#define         radius_wflex_l 25
#define           wflex_hand_l 26
#define                  hip_r 27
#define         knee_flexion_r 28
#define            knee_sd_jnt 29
#define              tib_pat_r 30
#define      patella_vv_corr_r 31
#define                ankle_r 32
#define             subtalar_r 33
#define                 toes_r 34
#define                  hip_l 35
#define       knee_flexion_l_1 36
#define       knee_flexion_l_2 37
#define              tib_pat_l 38
#define      patella_vv_corr_l 39
#define                ankle_l 40
#define             subtalar_l 41
#define                 toes_l 42

/************* Qs **************/
#define         lower_torso_TX  0   /* = sdindx(gnd_pelvis,0) */
#define         lower_torso_TY  1   /* = sdindx(gnd_pelvis,1) */
#define         lower_torso_TZ  2   /* = sdindx(gnd_pelvis,2) */
#define         lower_torso_RX  3   /* = sdindx(gnd_pelvis,1) */
#define         lower_torso_RY  4   /* = sdindx(gnd_pelvis,2) */
#define         lower_torso_RZ  5   /* = sdindx(gnd_pelvis,3) */
#define         pelvis_lum5_r3  6   /* = sdindx(pelvis_lum5,0) */
#define         pelvis_lum5_r1  7   /* = sdindx(pelvis_lum5,1) */
#define         pelvis_lum5_r2  8   /* = sdindx(pelvis_lum5,2) */
#define           lum5_lum4_r3  9   /* = sdindx(lum5_lum4,0) */
#define           lum5_lum4_r1 10   /* = sdindx(lum5_lum4,1) */
#define           lum5_lum4_r2 11   /* = sdindx(lum5_lum4,2) */
#define           lum4_lum3_r3 12   /* = sdindx(lum4_lum3,0) */
#define           lum4_lum3_r1 13   /* = sdindx(lum4_lum3,1) */
#define           lum4_lum3_r2 14   /* = sdindx(lum4_lum3,2) */
#define           lum3_lum2_r3 15   /* = sdindx(lum3_lum2,0) */
#define           lum3_lum2_r1 16   /* = sdindx(lum3_lum2,1) */
#define           lum3_lum2_r2 17   /* = sdindx(lum3_lum2,2) */
#define           lum2_lum1_r3 18   /* = sdindx(lum2_lum1,0) */
#define           lum2_lum1_r1 19   /* = sdindx(lum2_lum1,1) */
#define           lum2_lum1_r2 20   /* = sdindx(lum2_lum1,2) */
#define                fixed21 21   /* = sdindx(lum1_torso,0) */
#define           lumbar_pitch 22   /* = sdindx(lumbar_dof_jnt,3) */
#define            lumbar_roll 23   /* = sdindx(lumbar_dof_jnt,1) */
#define             lumbar_yaw 24   /* = sdindx(lumbar_dof_jnt,2) */
#define         torso_cerv7_r3 25   /* = sdindx(torso_cerv7,0) */
#define         torso_cerv7_r1 26   /* = sdindx(torso_cerv7,1) */
#define         torso_cerv7_r2 27   /* = sdindx(torso_cerv7,2) */
#define         cerv7_cerv6_r3 28   /* = sdindx(cerv7_cerv6,0) */
#define         cerv7_cerv6_r1 29   /* = sdindx(cerv7_cerv6,1) */
#define         cerv7_cerv6_r2 30   /* = sdindx(cerv7_cerv6,2) */
#define         cerv6_cerv5_r3 31   /* = sdindx(cerv6_cerv5,0) */
#define         cerv6_cerv5_r1 32   /* = sdindx(cerv6_cerv5,1) */
#define         cerv6_cerv5_r2 33   /* = sdindx(cerv6_cerv5,2) */
#define         cerv5_cerv4_r3 34   /* = sdindx(cerv5_cerv4,0) */
#define         cerv5_cerv4_r1 35   /* = sdindx(cerv5_cerv4,1) */
#define         cerv5_cerv4_r2 36   /* = sdindx(cerv5_cerv4,2) */
#define         cerv4_cerv3_r3 37   /* = sdindx(cerv4_cerv3,0) */
#define         cerv4_cerv3_r1 38   /* = sdindx(cerv4_cerv3,1) */
#define         cerv4_cerv3_r2 39   /* = sdindx(cerv4_cerv3,2) */
#define         cerv3_cerv2_r3 40   /* = sdindx(cerv3_cerv2,0) */
#define         cerv3_cerv2_r1 41   /* = sdindx(cerv3_cerv2,1) */
#define         cerv3_cerv2_r2 42   /* = sdindx(cerv3_cerv2,2) */
#define         cerv2_cerv1_r3 43   /* = sdindx(cerv2_cerv1,0) */
#define         cerv2_cerv1_r1 44   /* = sdindx(cerv2_cerv1,1) */
#define         cerv2_cerv1_r2 45   /* = sdindx(cerv2_cerv1,2) */
#define          cerv1_head_r3 46   /* = sdindx(cerv1_head,0) */
#define          cerv1_head_r1 47   /* = sdindx(cerv1_head,1) */
#define          cerv1_head_r2 48   /* = sdindx(cerv1_head,2) */
#define             neck_pitch 49   /* = sdindx(cervical_dof_jnt,3) */
#define              neck_roll 50   /* = sdindx(cervical_dof_jnt,1) */
#define               neck_yaw 51   /* = sdindx(cervical_dof_jnt,2) */
#define             arm_flex_r 52   /* = sdindx(acromial_r,3) */
#define              arm_add_r 53   /* = sdindx(acromial_r,1) */
#define              arm_rot_r 54   /* = sdindx(acromial_r,2) */
#define           elbow_flex_r 55   /* = sdindx(elbow_r,0) */
#define              pro_sup_r 56   /* = sdindx(radioulnar_r,0) */
#define                fixed57 57   /* = sdindx(radius_wflex_r,0) */
#define           wrist_flex_r 58   /* = sdindx(radius_wflex_r,1) */
#define            wrist_dev_r 59   /* = sdindx(wflex_hand_r,0) */
#define             arm_flex_l 60   /* = sdindx(acromial_l,3) */
#define              arm_add_l 61   /* = sdindx(acromial_l,-1) */
#define              arm_rot_l 62   /* = sdindx(acromial_l,-2) */
#define           elbow_flex_l 63   /* = sdindx(elbow_l,0) */
#define              pro_sup_l 64   /* = sdindx(radioulnar_l,0) */
#define                fixed65 65   /* = sdindx(radius_wflex_l,0) */
#define           wrist_flex_l 66   /* = sdindx(radius_wflex_l,1) */
#define            wrist_dev_l 67   /* = sdindx(wflex_hand_l,0) */
#define             hip_flex_r 68   /* = sdindx(hip_r,3) */
#define              hip_add_r 69   /* = sdindx(hip_r,1) */
#define              hip_rot_r 70   /* = sdindx(hip_r,2) */
#define      knee_flexion_r_tz 71   /* = sdindx(knee_flexion_r,0) */
#define      knee_flexion_r_tx 72   /* = sdindx(knee_flexion_r,1) */
#define      knee_flexion_r_ty 73   /* = sdindx(knee_flexion_r,2) */
#define      knee_flexion_r_r3 74   /* = sdindx(knee_flexion_r,3) */
#define              knee_vv_r 75   /* = sdindx(knee_flexion_r,4) */
#define                fixed76 76   /* = sdindx(knee_flexion_r,5) */
#define            knee_flex_r 77   /* = sdindx(knee_sd_jnt,0) */
#define           tib_pat_r_tx 78   /* = sdindx(tib_pat_r,0) */
#define           tib_pat_r_ty 79   /* = sdindx(tib_pat_r,1) */
#define           tib_pat_r_r3 80   /* = sdindx(tib_pat_r,2) */
#define   patella_vv_corr_r_r1 81   /* = sdindx(patella_vv_corr_r,0) */
#define           ankle_flex_r 82   /* = sdindx(ankle_r,0) */
#define           subt_angle_r 83   /* = sdindx(subtalar_r,0) */
#define            toe_angle_r 84   /* = sdindx(toes_r,0) */
#define             hip_flex_l 85   /* = sdindx(hip_l,3) */
#define              hip_add_l 86   /* = sdindx(hip_l,-1) */
#define              hip_rot_l 87   /* = sdindx(hip_l,-2) */
#define    knee_flexion_l_1_tx 88   /* = sdindx(knee_flexion_l_1,0) */
#define    knee_flexion_l_1_ty 89   /* = sdindx(knee_flexion_l_1,1) */
#define                fixed90 90   /* = sdindx(knee_flexion_l_1,2) */
#define            knee_flex_l 91   /* = sdindx(knee_flexion_l_2,0) */
#define              knee_vv_l 92   /* = sdindx(knee_flexion_l_2,1) */
#define           tib_pat_l_tx 93   /* = sdindx(tib_pat_l,0) */
#define           tib_pat_l_ty 94   /* = sdindx(tib_pat_l,1) */
#define           tib_pat_l_r3 95   /* = sdindx(tib_pat_l,2) */
#define   patella_vv_corr_l_r1 96   /* = sdindx(patella_vv_corr_l,0) */
#define           ankle_flex_l 97   /* = sdindx(ankle_l,0) */
#define           subt_angle_l 98   /* = sdindx(subtalar_l,0) */
#define            toe_angle_l 99   /* = sdindx(toes_l,0) */

/******* Constrained Qs ********/
#define     pelvis_lum5_r3_con  0
#define     pelvis_lum5_r1_con  1
#define     pelvis_lum5_r2_con  2
#define       lum5_lum4_r3_con  3
#define       lum5_lum4_r1_con  4
#define       lum5_lum4_r2_con  5
#define       lum4_lum3_r3_con  6
#define       lum4_lum3_r1_con  7
#define       lum4_lum3_r2_con  8
#define       lum3_lum2_r3_con  9
#define       lum3_lum2_r1_con 10
#define       lum3_lum2_r2_con 11
#define       lum2_lum1_r3_con 12
#define       lum2_lum1_r1_con 13
#define       lum2_lum1_r2_con 14
#define     torso_cerv7_r3_con 15
#define     torso_cerv7_r1_con 16
#define     torso_cerv7_r2_con 17
#define     cerv7_cerv6_r3_con 18
#define     cerv7_cerv6_r1_con 19
#define     cerv7_cerv6_r2_con 20
#define     cerv6_cerv5_r3_con 21
#define     cerv6_cerv5_r1_con 22
#define     cerv6_cerv5_r2_con 23
#define     cerv5_cerv4_r3_con 24
#define     cerv5_cerv4_r1_con 25
#define     cerv5_cerv4_r2_con 26
#define     cerv4_cerv3_r3_con 27
#define     cerv4_cerv3_r1_con 28
#define     cerv4_cerv3_r2_con 29
#define     cerv3_cerv2_r3_con 30
#define     cerv3_cerv2_r1_con 31
#define     cerv3_cerv2_r2_con 32
#define     cerv2_cerv1_r3_con 33
#define     cerv2_cerv1_r1_con 34
#define     cerv2_cerv1_r2_con 35
#define      cerv1_head_r3_con 36
#define      cerv1_head_r1_con 37
#define      cerv1_head_r2_con 38
#define  knee_flexion_r_tz_con 39
#define  knee_flexion_r_tx_con 40
#define  knee_flexion_r_ty_con 41
#define  knee_flexion_r_r3_con 42
#define       tib_pat_r_tx_con 43
#define       tib_pat_r_ty_con 44
#define       tib_pat_r_r3_con 45
#define patella_vv_corr_r_r1_con 46
#define knee_flexion_l_1_tx_con 47
#define knee_flexion_l_1_ty_con 48
#define       tib_pat_l_tx_con 49
#define       tib_pat_l_ty_con 50
#define       tib_pat_l_r3_con 51
#define patella_vv_corr_l_r1_con 52

/******** Body Segments ********/
#define                 ground -1
#define                 pelvis  0
#define                lumbar5  1
#define                lumbar4  2
#define                lumbar3  3
#define                lumbar2  4
#define                lumbar1  5
#define                  torso  6
#define             lumbar_dof  7
#define                  cerv7  8
#define                  cerv6  9
#define                  cerv5 10
#define                  cerv4 11
#define                  cerv3 12
#define                  cerv2 13
#define                  cerv1 14
#define                   head 15
#define               cerv_dof 16
#define              humerus_r 17
#define                 ulna_r 18
#define               radius_r 19
#define                wflex_r 20
#define                 hand_r 21
#define              humerus_l 22
#define                 ulna_l 23
#define               radius_l 24
#define                wflex_l 25
#define                 hand_l 26
#define                femur_r 27
#define                tibia_r 28
#define            knee_sd_seg 29
#define       patella_vv_tmp_r 30
#define              patella_r 31
#define                talus_r 32
#define                 foot_r 33
#define                 toes_r 34
#define                femur_l 35
#define            tibia_l_pre 36
#define                tibia_l 37
#define       patella_vv_tmp_l 38
#define              patella_l 39
#define                talus_l 40
#define                 foot_l 41
#define                 toes_l 42
